#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define FMBR "PC98MBR.BIN"
#define FBIN "PC98.BIN"
#define FFNT "PC98.FNT"

#define IGNCASE /* if you want NotIgnoreCase,CommentOut! */

int maxsect(int devno){
    union REGS iregs;
    int ms;

    iregs.h.ah=0x08;
    iregs.h.dl=devno;
    int86y(0x13,&iregs,&iregs);

/*    mc=iregs.h.ch+((iregs.h.cl&0xC0)>>6)*0x100;   */
/*    mh=iregs.h.dh+1;                              */
    ms=iregs.h.cl&0x3F;
    return(ms+1);
}

int readisk(char *buff,int devno,int c,int h,int s)
{
    union REGS iregs;

reload:
    iregs.h.ah=0x02;            /* Read(2) Write(3) */
    iregs.h.al=0x01;            /* Read sector(s) */
    iregs.h.ch=c&0x0FF;         /* Cyrinder lower8bits */
    iregs.h.cl=(s&0x0FF)+(c>>8);/* Sector(bit 0-5),Cyl upper 2bits */
    iregs.h.dh=h&0x0FF;         /* Head No. */
    iregs.h.dl=devno;           /* Drive.(0x80=1,0x81=2...) */
    iregs.x.es=FP_SEG(buff);    /* Segment of buffer */
    iregs.x.bx=FP_OFF(buff);    /* Offset of buffer */
    int86y(0x13,&iregs,&iregs); /* Interrupt 13h(Disk BIOS) */

    if(iregs.h.ah==6)goto reload;

    return(iregs.h.ah);
}

int wridisk(char *buff,int devno,int c,int h,int s)
{
    union REGS iregs;

    iregs.h.ah=0x03;            /* Read(2) Write(3) */
    iregs.h.al=0x01;            /* Read sector(s) */
    iregs.h.ch=c&0x0FF;         /* Cyrinder lower8bits */
    iregs.h.cl=(s&0x0FF)+(c>>8);/* Sector(bit 0-5),Cyl upper 2bits */
    iregs.h.dh=h&0x0FF;         /* Head No. */
    iregs.h.dl=devno;           /* Drive.(0x80=1,0x81=2...) */
    iregs.x.es=FP_SEG(buff);    /* Segment of buffer */
    iregs.x.bx=FP_OFF(buff);    /* Offset of buffer */
    int86y(0x13,&iregs,&iregs); /* Interrupt 13h(Disk BIOS) */

    return(iregs.h.ah);
}

int fsize(char *fname){
    FILE *fp;
    int len;

    if((fp=fopen(fname,"rb"))==NULL)return(-1);
    fseek(fp,0,SEEK_END);
    len=ftell(fp);
    fclose(fp);
    return(len);
}

int writer(char *fname,char *buff,int start,int length){
    FILE *fp;
    int i;

    if((fp=fopen(fname,"rb"))==NULL){
        printf("Can't open [%s]\n",fname);
        return(1);
    }

    for(i=0;i<length;i++){
        fread(buff,512,1,fp);
        wridisk(buff,0x80,0,0,i+start);
    }
    fclose(fp);

    return(0);
}

char isarg(int argc,char *argv[],char sw)
{
    char flag=0;

    while(--argc){
        char *s=*++argv;

        if(*s=='-'||*s=='/')
            while(*++s!=0)
                if(tolower(*s)==sw)
                    flag=1;
    }
    return(flag);
}

int mod_install_common(char *fnam,int mode){
    FILE *fp;
    char *buff;
    char *buff2;
    int i,s;
    int sectsize;/*=fsize(FBIN)/512+(fsize(FBIN)%512==0?0:1);*/

    printf("Mode:Install (%s) %d\n",fnam,maxsect(0x80));

    if((buff=malloc(512))==NULL){
        printf("Can't allocate memory(buffer1)...\n");
        exit(1);
    }
    if((buff2=malloc(512))==NULL){
        printf("Can't allocate memory(buffer2)...\n");
        exit(2);
    }

    sectsize=fsize(FBIN)/512+(fsize(FBIN)%512==0?0:1);

    readisk(buff,0x80,0,0,1);
    if(!strncmp(buff+3,"PC98",3)){
        printf("Already installed...\n");
        exit(3);
    }
    if(mode==0)
        wridisk(buff,0x80,0,0,2);
    else
        wridisk(buff,0x80,0,0,maxsect(0x80)-8-sectsize-1);

    if(mode==0){
        if(writer(fnam,buff,3,sectsize)){printf("Error writing [%s]!\n",fnam);exit(4);}
        if(writer(FFNT,buff,3+sectsize,8)){printf("Error writing [%s]!\n",FFNT);exit(5);}
    }else{
        if(writer(fnam,buff,maxsect(0x80)-8-sectsize,sectsize)){printf("Error writing [%s]!\n",fnam);exit(4);}
        if(writer(FFNT,buff,maxsect(0x80)-8,8)){printf("Error writing [%s]!\n",FFNT);exit(5);}
        readisk(buff,0x80,0,0,maxsect(0x80)-8-sectsize);
        buff[3]=maxsect(0x80)-8;
        buff[5]=maxsect(0x80)-8-sectsize-1;
        wridisk(buff,0x80,0,0,maxsect(0x80)-8-sectsize);
    }

    if((fp=fopen(FMBR,"rb"))==NULL){
        printf("Can't open %s\n",FMBR);
        exit(6);
    }
    fread(buff,512,1,fp);
    readisk(buff2,0x80,0,0,1);
    s=fsize(FMBR);
    printf("MBR code [%d] bytes.\n",s);
    for(i=0;i<s;i++)buff2[i]=buff[i];
    if(mode!=0)
        buff2[7]=maxsect(0x80)-8-sectsize;
    wridisk(buff2,0x80,0,0,1);
    fclose(fp);

    free(buff);
    free(buff2);

    printf("Install successful!\n");
}

int mod_install(char *fnam){
    if(!strcmp(fnam,"")){
        strcpy(fnam,FBIN);
    }
    mod_install_common(fnam,0);
}

int mod_install_l(char *fnam){
    if(!strcmp(fnam,"")){
        strcpy(fnam,FBIN);
    }
    mod_install_common(fnam,1);
}

int mod_uninstall(){
    char *buff;
    char *buff2;
    int i;
    int sectsize;

    printf("Mode:Uninstall\n");

    if((buff=malloc(512))==NULL){
        printf("Can't allocate memory(buffer1)...\n");
        exit(1);
    }
    if((buff2=malloc(512))==NULL){
        printf("Can't allocate memory(buffer2)...\n");
        exit(2);
    }

    readisk(buff,0x80,0,0,1);
    if(strncmp(buff+3,"PC98",3)){
        printf("Not installed...\n");
        exit(3);
    }

    sectsize=fsize(FBIN)/512+(fsize(FBIN)%512==0?0:1);

    printf("(Updating MBR-Table)\n");
    readisk(buff,0x80,0,0,1);
    if(buff[7]==3)
        readisk(buff2,0x80,0,0,2);
    else
        readisk(buff2,0x80,0,0,maxsect(0x80)-8-sectsize-1);
    for(i=512-16*4-2;i<512-2;i++)buff2[i]=buff[i];
    if(buff[7]==3)
        wridisk(buff2,0x80,0,0,2);
    else
        wridisk(buff2,0x80,0,0,maxsect(0x80)-8-sectsize-1);

    if(buff[7]==3)
        readisk(buff,0x80,0,0,2);
    else
        readisk(buff,0x80,0,0,maxsect(0x80)-8-sectsize-1);
    wridisk(buff,0x80,0,0,1);

    free(buff);
    free(buff2);

    printf("Uninstall successful!\n");
}

int mod_update(){
    char *buff;
    char *buff2;
    int i;
    int sectsize;

    printf("Mode:Update\n");

    if((buff=malloc(512))==NULL){
        printf("Can't allocate memory(buffer1)...\n");
        exit(1);
    }
    if((buff2=malloc(512))==NULL){
        printf("Can't allocate memory(buffer2)...\n");
        exit(2);
    }

    sectsize=fsize(FBIN)/512+(fsize(FBIN)%512==0?0:1);

    readisk(buff,0x80,0,0,1);
    if(buff[7]==3)
        readisk(buff2,0x80,0,0,2);
    else
        readisk(buff2,0x80,0,0,maxsect(0x80)-8-sectsize-1);
    if(strncmp(buff+3,"PC98",3)){
        printf("Not installed...\n");
        exit(3);
    }
    for(i=512-16*4-2;i<512-2;i++)buff2[i]=buff[i];
    if(buff[7]==3)
        wridisk(buff2,0x80,0,0,2);
    else
        wridisk(buff2,0x80,0,0,maxsect(0x80)-8-sectsize-1);

    free(buff);
    free(buff2);

    printf("Update successful!\n");
}

int mod_check(){
    char *buff;

    printf("Mode:Check\n");

    if((buff=malloc(512))==NULL){
        printf("Can't allocate memory(buffer1)...\n");
        exit(1);
    }

    readisk(buff,0x80,0,0,1);
    if(strncmp(buff+3,"PC98",3)){
        printf("Not installed\n");
    }else{
        if(buff[7]==3)
            printf("Installed\n");
        else
            printf("Installed(on last)\n");
    }

    free(buff);
}

int main(int argc,char *argv[])
{
    char mode[16],fname[16],did=0;

    printf("PC98-MBR tool ver.20041212 - by Murachue\n");

    strcpy(mode,"");
    strcpy(fname,"");

    while(--argc){
        char *s=*++argv;

        if(*s!='-'&&*s!='/'){
            char flag=0,*p=s;
            while(*p++!=0)
                if(*p=='.')
                    flag=1;

            if(flag==0){
                strcpy(mode,*argv);
#ifdef IGNCASE
                strlwr(mode);
#endif
            }else{
                strcpy(fname,*argv);
            }
        }
    }

#ifndef IGNCASE
    if(!strcmp(mode,"Install")){did=1;mod_install(fname);}
    if(!strcmp(mode,"Install-L")){did=1;mod_install_l(fname);}
    if(!strcmp(mode,"Uninstall")){did=1;mod_uninstall();}
    if(!strcmp(mode,"Update")){did=1;mod_update();}
#else
    if(!strcmp(mode,"install")){did=1;mod_install(fname);}
    if(!strcmp(mode,"install-l")){did=1;mod_install_l(fname);}
    if(!strcmp(mode,"uninstall")){did=1;mod_uninstall();}
    if(!strcmp(mode,"update")){did=1;mod_update();}
#endif
    if(!strcmp(mode,"check")){did=1;mod_check();}
    if(!did){
        printf("Usage: inst MODE [filename]\n");
#ifndef IGNCASE
        printf(" Install     : install PC98-MBR(default=%s)\n",FBIN);
        printf(" Install-L   : install PC98-MBR to last Sect.(default=%s)\n",FBIN);
        printf(" Uninstall   : uninstall PC98-MBR(install previous MBR)\n");
        printf(" Update      : Update sector2's MBR-Table\n");
#else
        printf(" install     : install PC98-MBR(default=%s)\n",FBIN);
        printf(" install-l   : install PC98-MBR to last Sect.(default=%s)\n",FBIN);
        printf(" uninstall   : uninstall PC98-MBR(install previous MBR)\n");
        printf(" update      : Update sector2's MBR-Table\n");
#endif
        printf(" check       : Check installed PC98-MBR\n");
#ifndef IGNCASE
        printf("Alphabet case NOT ignored!\n");
#endif
        printf("** NO SUPPORT,NO WARRANTY!! **\n");
    }
}
